Setting ‘Bing Ads Audience Estimation’ Tasks


This endpoint provides estimated audience size for an ad campaign based on specified targeting criteria. It returns data on the total estimated audience, such as suggested bid and budget for an ad campaign and estimated engagement metrics.

This is the Standard method of data retrieval. If you don’t need to receive data in real-time, this method is the best option for you. Set a task and retrieve the results when our system collects them. Execution time depends on the system workload.

If your system requires delivering instant results, the Live method will be a better solution. This method doesn’t require making separate POST and GET requests to the corresponding endpoints.

checked POST
Pricing

Your account will be charged only for setting a task.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). Task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, with each POST call containing no more than 100 tasks. If your POST call contains over 100 tasks, the tasks over this limit will return the 40006 error. Visit DataForSEO Help Center to get practical tips for request handling depending on your Keyword Data API payload volume.

You can also retrieve the results of completed tasks using the unique task identifier id. Alternatively, we can send them to you as soon as they are ready if you specify the postback_url or pingback_url when setting a task. Note that if your server doesn’t respond within 10 seconds, the connection will be aborted by timeout, and the task will be transferred to the tasks_ready list. The error code and message depend on your server’s configuration.

See Help Center to learn more about using pingbacks and postbacks with DataForSEO APIs.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
location_namestring

full name of search engine location
required field if you don't specify location_code or location_coordinate
if you use this field, you don't need to specify location_code or location_coordinate
you can receive the list of available locations of the search engine with their location_name by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/locations
example:
London,England,United Kingdom

location_codeinteger

search engine location code
required field if you don't specify location_name or location_coordinate
if you use this field, you don't need to specify location_name or location_coordinate
you can receive the list of available locations of the search engines with their location_code by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/locations
example:
2840

location_coordinatestring

GPS coordinates of a location
required field if you don't specify location_name or location_code
if you use this field, you don't need to specify location_name or location_code
location_coordinate parameter should be specified in the "latitude,longitude,radius (in km)" format
the data will be provided for the country the specified coordinates belong to
example:
29.6821525,-82.4098881,100

agearray

selection of age ranges for targeting
possible values: eighteen_to_twenty_four, fifty_to_sixty_four, sixty_five_and_above, thirteen_to_seventeen, thirty_five_to_forty_nine, twenty_five_to_thirty_four, unknown, zero_to_twelve

bidfloat

desired bid setting value in USD
maximum value: 1000

daily_budgetfloat

daily campaign budget value in USD
maximum value: 10000

genderarray

gender to target
possible values: male, female, unknown

industryarray

industry of LinkedIn profile targeting

if you use this field, you can receive the list of available industry names with industry_id by making a separate request to the https://api.dataforseo.com/v3/keywords_data/bing/audience_estimation/industries

example: 806301758

job_functionarray

job function of LinkedIn profile targeting

if you use this field, you can receive the list of available job function names with job_function_id by making a separate request to the https://api.dataforseo.com/v3/keywords_data/bing/audience_estimation/job_functions

example: 806300451

As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

 

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasksarray

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

unique task identifier in our system
unique task identifier in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results
in this case, the value will be null


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/keywords_data/bing/audience_estimation/task_post" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
  {
    "location_coordinate": "29.6821525,-82.4098881,100",
    "age": [
      "twenty_five_to_thirty_four",
      "eighteen_to_twenty_four",
      "unknown"
    ],
    "bid": 1,
    "daily_budget": 24,
    "gender": [
      "male"
    ],
    "industry": [
      806303407,
      806301758
    ],
    "job_function": [
      806298607
    ]
  }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');

$post_array = array();
// simple way to set a task
$post_array[] = array(
	"location_code" =gt; 2840,	
	"bid" =gt; 10
);
try {
	// POST /v3/keywords_data/bing/audience_estimation/task_post
	// the full list of possible parameters is available in documentation
	$result = $client-gt;post('/v3/keywords_data/bing/audience_estimation/task_post', $post_array);
	print_r($result);
	// do something with post result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e-gt;getHttpCode()}n";
	print "Error code: {$e-gt;getCode()}n";
	print "Message: {$e-gt;getMessage()}n";
	print  $e-gt;getTraceAsString();
	echo "n";
}
$client = null;
?>
var request = require('request');
var options = {
  'method': 'POST',
  'url': 'https://api.dataforseo.com/v3/keywords_data/bing/audience_estimation/task_post',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': '••••••'
  },
  body: JSON.stringify([
    {
      "location_coordinate": "29.6821525,-82.4098881,100",
      "age": [
        "twenty_five_to_thirty_four",
        "eighteen_to_twenty_four",
        "unknown"
      ],
      "bid": 1,
      "daily_budget": 24,
      "gender": [
        "male"
      ],
      "industry": [
        806303407,
        806301758
      ],
      "job_function": [
        806298607
      ]
    }
  ])

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    location_code=2840,
    bid=10
)
# POST /v3/keywords_data/bing/audience_estimation/task_post
# the full list of possible parameters is available in documentation
response = client.post("/v3/keywords_data/bing/audience_estimation/task_post", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task keywords_data_bing_audience_estimation_task_post()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            postData.Add(new
            {
                location_code = 2840,
                bid = 10
            });
            // POST /v3/keywords_data/bing/audience_estimation/task_post
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/keywords_data/bing/audience_estimation/task_post", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20240801",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0.1243 sec.",
  "cost": 0.05,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "09271515-1535-0594-0000-37caebb347d4",
      "status_code": 20100,
      "status_message": "Task Created.",
      "time": "0.0019 sec.",
      "cost": 0.05,
      "result_count": 0,
      "path": [
        "v3",
        "keywords_data",
        "bing",
        "audience_estimation",
        "task_post"
      ],
      "data": {
        "api": "keywords_data",
        "function": "audience_estimation",
        "se": "bing",
        "location_coordinate": "29.6821525,-82.4098881,100",
        "age": [
          "twenty_five_to_thirty_four",
          "eighteen_to_twenty_four",
          "unknown"
        ],
        "bid": 1,
        "daily_budget": 24,
        "gender": [
          "male"
        ],
        "industry": [
          806303407,
          806301758
        ],
        "job_function": [
          806298607
        ]
      },
      "result": null
    }
  ]
}